<template>
  <AppModal
    name-modal="modal-fast-order"
    :width-modal="720"
    :no-header="orderSent"
    :visible="visible"
    :gray-header="true"
    @before-close="onBeforeClose"
    @before-open="beforeOpen"
    init-class="modalFastOrder">
    <template
      #header
      v-if="!orderSent">
      <div class="heading">
        Быстрый заказ
      </div>
    </template>

    <template #body>
      <div
        v-if="orderSent"
        class="orderSuccess">
        <img
          svg-inline
          src="~/assets/svg/redesign/ok-big.svg">
        <div class="heading">Заказ отправлен!</div>
        <div class="paragraph">Продавец перезвонит вам по указанному номеру в&nbsp;течение&nbsp;10&nbsp;минут!</div>
        <div class="paragraph __gray">График работы продавца:
          <span class="__no-wrap">ежедневно с 8:00 до 22:00</span>
        </div>
      </div>

      <!-- TODO: -->
      <!-- разобраться, если модалка рендерится на странице через v-if, -->
      <!-- то вызов не сработает без $nextTick или проверки prop visible при mounted() -->
      <div
        v-if="!orderSent"
        class="modalFastOrder-heading">
        Продавец перезвонит вам в&nbsp;течение 10&nbsp;минут для&nbsp;подтвержения&nbsp;заказа
      </div>
      <div class="row">
        <div
          v-if="order && Object.keys(order).length"
          class="orderCart"
          :class="{ '_order-sent': orderSent }">
          <div class="orderCart-item">
            <div class="orderCart-heading">
              {{ part.contractModal.brand }}, {{ part.contractModal.vendorCode }}
            </div>
            <div>{{ part.contractModal.nameStandard }}</div>
          </div>
          <div class="orderCart-item _counter">
            <div class="orderCart-calculation">
              <AppInputNumber
                v-if="!orderSent"
                class="_small"
                :value="count"
                @changeCount="count = $event"
                :max-value="seller.availableCount"/>
              <div v-else>
                {{ count }}
              </div>
              <div class="orderCart-value">
                x&nbsp;&nbsp;{{ part.contractModal.price | spacifyNumber }}&nbsp;₽
              </div>
              <div class="orderCart-total">
                <span class="total">Итого&nbsp;&nbsp;</span>
                {{ total | spacifyNumber }} ₽
              </div>
            </div>
          </div>
          <div class="orderCart-item">
            <div class="seller">
              <!-- TODO: нет такого функционала -->
              <!-- Рейтинг  Отзывы -->
              <!-- <div class="seller-rating">
                <AppRating current-rating="2"/>
                <span class="__gray __no-wrap">&nbsp;&nbsp;10 отзывов</span>
              </div>-->
              <span class="__medium">Продавец:</span>
              <span class="seller-name">
                <!-- <img
                  v-if="false"
                  svg-inline
                  src="~/assets/svg/redesign/ok-small-blue.svg">-->
                {{ seller.name }},
              </span>
              <span class="seller-address">
                <span v-if="seller.city">
                  {{ seller.city }},
                </span>
                <!--TODO: нет такого функционала   -->
                <!--<span class="seller-metro __no-wrap  __gray">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/metro.svg">
                  Заельцовская (1.5 км),
                </span>-->
                <span>
                  {{ getAddressByPart(seller) }}
                </span>
              </span>
              <!-- Контакт подтвержден -->
            </div>
          </div>
          <div
            v-if="part.contractModal.inStock"
            class="orderCart-item">
            <span class="__medium">В наличии:</span>
            {{ seller.availableCount | spacifyNumber }} шт.
          </div>
        </div>
        <!--        TODO: Нужен tag form и submit-->
        <div
          v-if="!orderSent"
          class='orderForm'>
          <div class="form">
            <div class="form-heading">
              Продавец перезвонит вам в&nbsp;течение 10&nbsp;минут для&nbsp;подтвержения&nbsp;заказа
            </div>
            <div class="form-item">
              <AppCitySearch
                v-model="city"
                :composite="false"
                placeholder="Ваш город *"
                :classes="{'-invalid': validation.hasError('city')}"/>
              <div
                v-if="validation.hasError('city')"
                class="input-message-error _left">
                {{ validation.firstError('city') }}
              </div>
            </div>

            <div class="form-item">
              <div
                class="input"
                :class="{ '-invalid': validation.hasError('name') }">
                <input
                  v-model="name"
                  class="input-field"
                  placeholder="Ваше имя">
              </div>
            </div>

            <div class="form-item">
              <AppInputPhone
                v-model="phone"
                :composite="false"
                :options="{ validationRule: { isRequired: true } }"
                :has-validate="loading"
                @has-error="onGetError"/>
            </div>

            <div class="form-item">
              <div
                class="input"
                :class="{ '-invalid': validation.hasError('email') }">
                <input
                  v-model="email"
                  class="input-field"
                  placeholder="Ваш email">
              </div>
              <div
                v-if="validation.hasError('email')"
                class="input-message-error _left">
                {{ validation.firstError('email') }}
              </div>
            </div>

            <div class="form-item">
              <div class="input">
                <textarea
                  v-model="comment"
                  class="input-field _textarea"
                  placeholder="Комментарий продавцу"/>
              </div>
            </div>

            <div
              class="form-item"
              v-if="formError">
              <div
                class="input-message-error"
                v-html="formError"/>
            </div>

            <div class="form-item">
              <AppCheckbox
                v-model="isAgree"
                :class="{'-invalid': validation.hasError('isAgree')}">
                <template #label>
                  Я подтверждаю, что прочел
                  <flink
                    href="/about-us/regulations"
                    target="_blank"
                    class="link">условия работы
                  </flink>
                  портала.
                </template>
              </AppCheckbox>
            </div>

            <div class="form-submit">
              <AppButton
                :disabled="disabled"
                @click.native="send">
                <template #button-item>
                  Отправить заказ
                </template>
              </AppButton>
            </div>
          </div>
        </div>
      </div>
      <div
        v-if="orderSent"
        class="orderContinue">
        <AppButton @click.native="hideModal(); $ym('continue_select_parts')">
          <template #button-item>
            Продолжить выбор запчастей
            <img
              svg-inline
              src="~/assets/svg/redesign/button-arrow-right.svg">
          </template>
        </AppButton>
      </div>
    </template>
  </AppModal>
</template>

<script>
import SimpleVueValidation from 'simple-vue-validator';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputNumber from '~/components/redesign/app-input/app-input-number';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import AppRating from '~/components/redesign/app-rating';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';
import Modals from '~/assets/js/mixins/redesign/modals';
import { get, isEmpty } from 'lodash-es';
import Item from '~/assets/js/model/item/item';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Некорректный формат e-mail',
  },
});

export default {
  name: 'AppModalFastOrder',
  components: {
    AppRating,
    AppCheckbox,
    AppModal,
    AppButton,
    AppInputNumber,
    AppInputComposite,
    AppInputPhone,
    AppCitySearch,
  },
  mixins: [Modals],
  props: {
    user: {
      type: Object,
      default() { return {}; },
    },
    order: {
      type: Object,
      default() { return {}; },
    },
    visible: {
      type: Boolean,
      default: false,
    },
    scrollable: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    // TODO: Вполне возможно лучшим решением будет вынести в hepler функцию создания usera.
    // TODO: Нужен компонент FastOrder
    const hasAuth = !isEmpty(this.user);
    return {
      formError: '',
      loading: false,
      comment: '',
      orderSent: false,
      isAgree: false,
      email: hasAuth && this.user.chatRole !== 'guest' ? get(this.user, 'username', '') : '',
      name: hasAuth ? get(this.user, 'userProfile.firstName', '') : '',
      phone: hasAuth ? get(this.user, 'userProfile.phone', '') : '',
      city: {
        id: hasAuth ? get(this.user, 'userProfile.city.id', '') : get(this.$store.state.location, 'id', 0),
        name: hasAuth ? get(this.user, 'userProfile.city.name', '') : get(this.$store.state.location, 'name', ''),
        region: hasAuth ? get(this.user, 'userProfile.city.parent.name', '') : '',
      },
      count: (this.part && this.part.contractModal && this.part.contractModal.quantity)
        ? this.part.contractModal.quantity
        : 1,
      hasPhoneError: false,
    };
  },
  computed: {
    hideEmailField() {
      return Boolean(this.user) && this.user.chatRole !== 'guest';
    },
    part() {
      return this.order && this.order.part;
    },
    seller() {
      return this.order && this.order.seller;
    },
    total() {
      return ((this.count || 0) * (this.part.contractModal.price || 0)).toFixed(2);
    },
    isYourProduct() {
      if (this.part) {
        return Item.isOwnedByUser(this.user && this.user.id, this.part);
      }

      return false;
    },
    hasFieldsErrors() {
      return this.validation.hasError('isAgree')
        || this.validation.hasError('city')
        || this.validation.hasError('email')
        || this.hasPhoneError;
    },
    disabled() {
      return !this.phone
        || isEmpty(this.city)
        || !this.isAgree
        || this.isYourProduct
        || this.hasFieldsErrors;
    },
  },
  validators: {
    city(value) {
      return SimpleVueValidator.value(value).required();
    },
    email(value) {
      return SimpleVueValidator.value(value).email();
    },
    isAgree(value) {
      return SimpleVueValidator.value(value).custom(() => !value);
    },
  },
  methods: {
    onBeforeClose() {
      if (this.orderSent) {
        this.$ym('close_order_sent');
      } else {
        this.$ym('close_сheckout');
      }

      this.$emit('before-close');
      this.validation.reset();
    },
    onGetError(error) {
      this.hasPhoneError = error;
    },
    hideModal() {
      this.$modal.hide('modal-fast-order');
    },
    beforeOpen() {
      this.orderSent = false;
    },
    getAddressByPart(part) {
      const result = [];

      if (part.is_netshop) {
        result.push('интернет магазин');
      } else {
        if (part.street) {
          result.push(part.street);
        }
        if (part.building) {
          result.push(part.building);
        }
        if (part.office) {
          result.push(`офис ${part.office}`);
        }
      }

      return result.join(', ');
    },
    async send() {
      this.loading = true;
      const isValid = await this.$validate() && !this.hasPhoneError;

      if (!isValid) {
        return;
      }

      const isOrderSentSuccess = await this.$axios.$post('/_main/part/createFastOrder', {
        itemId: Number(this.part.contractModal.itemId),
        itemQuantity: this.count,
        itemIsWholesale: this.part.contractModal.isWholesalePrice,
        customerName: this.name ? this.name : 'Не указано',
        customerEmail: this.email,
        customerCityId: Number(this.city.id),
        customerPhone: this.phone,
        customerComment: this.comment,
      }).catch((e) => {
        if (e.response.status === 401) {
          this.hideModal();
          this.$modal.show('modal-auth');
        } else {
          this.formError = 'Временная ошибка, пожалуйста, повторите запрос позднее';
        }
        console.log(e);
        return false;
      }).finally(() => {
        this.loading = false;
      });

      if (isOrderSentSuccess) {
        this.orderSent = true;
        this.$ym('quick_order');
        this.$gtm({
          event: 'ordersend',
        });
        this.$statPpn('send-order-quick', {
          shopId: this.seller.id,
          brandId: this.part.contractModal.manufacturerId,
          partId: this.part.contractModal.partId,
          itemId: this.part.contractModal.itemId,
          itemName: this.part.contractModal.name,
          brandName: this.part.contractModal.brand,
          partNumber: this.part.contractModal.vendorCode,
          partName: this.part.contractModal.nameStandard,
        });
        this.validation.reset();
      }
    },
  },
};
</script>

<style lang="postcss">
  .modalFastOrder {
    .appModal-header {
      flex-shrink: 1;
      text-align: center;

      .heading {
        width: 100%;
      }
    }

    &-heading {
      display: block;
      padding: 1rem;
      font-size: 0.875rem;
      text-align: center;
    }

    .row {
      align-items: stretch;
    }

    .seller {
      display: block;

      &-rating {
        display: flex;
        padding-bottom: 0.25rem;
      }

      &-metro {
        display: inline-block;

        .svg {
          display: inline-block;
          flex-shrink: 0;
          margin: -0.125rem 0.375rem -0.125rem 0;
        }
      }

      &-name {
        color: var(--link-color);
        font-weight: var(--font-weight-medium);
        .svg {
          fill: var(--link-color);
          flex-shrink: 0;
          margin-right: 0.375rem;
        }
      }
    }

    .orderCart {
      display: flex;
      flex-direction: column;
      padding: 0 1rem 2rem 2rem;;
      width: 50%;
      font-size: 0.875rem;

      &._order-sent {
        padding: 1rem 2rem;
        width: 100%;

        .orderCart-value {
          margin-right: 1.5rem;
        }
      }

      &-heading {
        font-weight: bold;
        padding-bottom: 0.25rem;
      }

      &-desktop {
        padding-top: 0.75rem;
      }

      &-item {
        display: block;
        padding-bottom: 0.5rem;
        width: 100%;
        &:last-child {
          padding-bottom: 0;
        }
      }

      &-calculation {
        display: flex;
        flex-wrap: wrap;
        align-items: center;
        .inputNumber {
          margin: 0.5rem 0;
        }

        .total {
          display: none;
        }
      }
      &-value {
        display: block;
        padding: 0 0.5rem;
        margin-right: auto;
        font-size: 0.75rem;
        white-space: nowrap;
      }

      &-total {
        display: block;
        font-family: var(--font-heading);
        font-size: 1.25rem;
        font-weight: var(--font-weight-extra-bold);
        white-space: nowrap;
      }

      .input.inputCheck {
        margin-top: auto;
      }
    }

    .orderSuccess {
      padding: 1.5rem 1.25rem;
      text-align: center;
      background-color: var(--btn-light-bg);
      border-bottom: 1px solid var(--border-color-main);
      .svg {
        height: 80px;
        width: 80px;
      }
      .heading {
        padding: 1rem 0;
      }
      .paragraph {
        padding-bottom: 0.5rem;
      }
    }

    .orderForm {
      padding: 0 2rem 2rem 1rem;
      width: 50%;

      .form {
        display: block;
        margin: 0 auto;
        width: 100%;
        max-width: 21.25rem;

        &-heading {
          display: none;
        }

        &-submit {
          .button {
            width: 100%;
            height: var(--btn-height-regular);
          }
        }

        &-item {
          font-size: 0.75rem;
          padding-bottom: 0.5rem;

          &._agree {
            position: relative;
            padding-bottom: 0;
            .inputCheck {
              position: absolute;
              right: 100%;
              margin: 0.625rem 2rem;
            }
          }

          &._column {
            flex-direction: column;
          }
          &._flex-start {
            justify-content: flex-start;
            align-items: flex-start;
          }

          .inputComposite {
            width: 100%;
            min-width: 17rem;
          }

          .input-message-error {
            display: block;
            &._left {
              text-align: left;
            }
          }

          .inputCheck-label {
            font-size: 0.75rem;
          }

          .link {
            white-space: nowrap;
          }
        }
      }
    }

    .orderContinue {
      padding: 1.5rem 1.25rem;
      text-align: center;
      background-color: var(--btn-light-bg);
      .button {
        height: var(--btn-height-regular);
        .svg {
          margin-left: 0.5rem;
        }
      }
    }

    @media screen and (max-width: 980px) {
      min-height: 100vh;

      .appModal-header:not(._no-header) {
        padding: 0;
        height: 4.375rem;
        border-bottom: 1px solid var(--border-color-main);
        .heading {
          font-size: 1.375rem;
        }
      }

      .appModal-body {
        padding-bottom: calc(2rem + var(--mobile-browser-bar));
        background-color: var(--bg-dark);
      }

      &-heading {
        display: none;
      }

      .row {
        flex-wrap: wrap;
      }

      .seller {
        font-size: 1rem;
      }

      .orderCart {
        width: 100%;
        padding: 1.25rem;
        font-size: 1rem;
        background-color: var(--bg-main);
        border-bottom: 1px solid var(--border-color-main);

        &-value {
          font-size: inherit;
        }

        &-total {
          width: 100%;
          padding-top: 0.5rem;
          font-size: 1.5rem;
          .total {
            display: inline;
          }
        }
      }

      .orderForm {
        width: 100%;
        padding: 1.25rem 1.25rem 0;


        .form-heading {
          display: block;
          padding-bottom: 1.5rem;
          font-size: 1rem;
          text-align: center;
        }

        .form-item._agree .inputCheck {
          position: static;
          margin: 0 0 1rem;
        }

        .button {
          width: 100%;
          font-size: 1rem;
        }
      }

      .orderSuccess {
        position: relative;
        padding: 1.25rem 2rem 1.25rem 4.75rem;
        text-align: left;
        background-color: transparent;
        .svg {
          position: absolute;
          left: 1.25rem;
          top: 1.5rem;
          display: block;
          width: 2.5rem;
          height: auto;
        }
        .heading {
          padding-top: 0.25rem;
          font-size: 1.375rem;
        }
        .paragraph {
          padding-bottom: 0.5rem;
          max-width: 20rem;
          font-size: 1rem;
        }
      }

      .orderContinue {
        background-color: transparent;
        .button {
          width: 100%;
          font-size: 1rem;

          .svg {
            margin-left: 1rem;
            width: 0.375rem;
            height: auto;
          }
        }
      }
    }
  }
</style>
